> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Redirect

POST https://api.bigcommerce.com/stores/{store_hash}/v2/redirects
Content-Type: application/json

Creates a *Redirect URL*.

**Required Fields**
*   path
*   forward

**Read Only**
*   url


> #### Warning
> **Deprecated**
> * This API operation is deprecated. Avoid using this API operation if possible. It will be removed in a future version.
> * To upsert new redirect data, use Redirects V3ʼs [Upsert redirects](/developer/api-reference/rest/admin/management/redirects/upsert-redirects) endpoint.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/content/store-content/redirects/create-redirect

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Content | modify | `store_v2_content` | | Content | read-only | `store_v2_content_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a redirect.

- `path` (string, required) — The path from which to redirect.
- `forward` (forward, required)
- `id` (integer, optional) — Numeric ID of the redirect.
- `url` (string, optional) — URL of the redirect. READ-ONLY.

## Response

### 200

OK

- `path` (string, required) — The path from which to redirect.
- `forward` (forward, required)
- `id` (integer, optional) — Numeric ID of the redirect.
- `url` (string, optional) — URL of the redirect. READ-ONLY.

## Types

### forward

- `type` (string, optional) — The type of redirect. If it is a `manual` redirect then type will always be manual. Dynamic redirects will have the type of the page. Such as product or category.
- `ref` (integer, optional) — Reference of the redirect. Dynamic redirects will have the category or product number. Manual redirects will have the url that is being directed to.

## Examples

**Request**

```json
{
  "path": "/smith-journal-13/",
  "forward": {
    "type": "product",
    "ref": 111
  },
  "id": 1
}
```

**Response**

```json
{
  "path": "/mens_clothing",
  "forward": {
    "type": "category",
    "ref": 3
  },
  "id": 3,
  "url": "http://store.example.com/mens"
}
```

**SDK Code**

```python Response
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v2/redirects"

payload = {
    "path": "/smith-journal-13/",
    "forward": {
        "type": "product",
        "ref": 111
    },
    "id": 1
}
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Response
const url = 'https://api.bigcommerce.com/stores/store_hash/v2/redirects';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '{"path":"/smith-journal-13/","forward":{"type":"product","ref":111},"id":1}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v2/redirects"

	payload := strings.NewReader("{\n  \"path\": \"/smith-journal-13/\",\n  \"forward\": {\n    \"type\": \"product\",\n    \"ref\": 111\n  },\n  \"id\": 1\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Response
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v2/redirects")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"path\": \"/smith-journal-13/\",\n  \"forward\": {\n    \"type\": \"product\",\n    \"ref\": 111\n  },\n  \"id\": 1\n}"

response = http.request(request)
puts response.read_body
```

```java Response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v2/redirects")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"path\": \"/smith-journal-13/\",\n  \"forward\": {\n    \"type\": \"product\",\n    \"ref\": 111\n  },\n  \"id\": 1\n}")
  .asString();
```

```php Response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v2/redirects', [
  'body' => '{
  "path": "/smith-journal-13/",
  "forward": {
    "type": "product",
    "ref": 111
  },
  "id": 1
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Response
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v2/redirects");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"path\": \"/smith-journal-13/\",\n  \"forward\": {\n    \"type\": \"product\",\n    \"ref\": 111\n  },\n  \"id\": 1\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Response
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "path": "/smith-journal-13/",
  "forward": [
    "type": "product",
    "ref": 111
  ],
  "id": 1
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v2/redirects")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```